.\"     Title: abc::messages
.\"    Author: Jan CTU in Prague Schmidt <jan.schmidt@fit.cvut.cz>
.\" Generator: DocBook XSL Stylesheets v1.74.0 <http://docbook.sf.net/>
.\"      Date: 12/21/2010
.\"    Manual: Reference Pages
.\"    Source: ABCTcl 0.6
.\"  Language: English
.\"
.TH "ABC::MESSAGES" "n" "12/21/2010" "ABCTcl 0.6" "Reference Pages"
.\" -----------------------------------------------------------------
.\" * (re)Define some macros
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" toupper - uppercase a string (locale-aware)
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de toupper
.tr aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ
\\$*
.tr aabbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH-xref - format a cross-reference to an SH section
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de SH-xref
.ie n \{\
.\}
.toupper \\$*
.el \{\
\\$*
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH - level-one heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SH
.\" put an extra blank line of space above the head in non-TTY output
.if t \{\
.sp 1
.\}
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[an-margin]u
.ti 0
.HTML-TAG ".NH \\n[an-level]"
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
\." make the size of the head bigger
.ps +3
.ft B
.ne (2v + 1u)
.ie n \{\
.\" if n (TTY output), use uppercase
.toupper \\$*
.\}
.el \{\
.nr an-break-flag 0
.\" if not n (not TTY), use normal case (not uppercase)
\\$1
.in \\n[an-margin]u
.ti 0
.\" if not n (not TTY), put a border/line under subheading
.sp -.6
\l'\n(.lu'
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SS - level-two heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SS
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[IN]u
.ti \\n[SN]u
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
.ps \\n[PS-SS]u
\." make the size of the head bigger
.ps +2
.ft B
.ne (2v + 1u)
.if \\n[.$] \&\\$*
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BB/BE - put background/screen (filled box) around block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BB
.if t \{\
.sp -.5
.br
.in +2n
.ll -2n
.gcolor red
.di BX
.\}
..
.de EB
.if t \{\
.if "\\$2"adjust-for-leading-newline" \{\
.sp -1
.\}
.br
.di
.in
.ll
.gcolor
.nr BW \\n(.lu-\\n(.i
.nr BH \\n(dn+.5v
.ne \\n(BHu+.5v
.ie "\\$2"adjust-for-leading-newline" \{\
\M[\\$1]\h'1n'\v'+.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.el \{\
\M[\\$1]\h'1n'\v'-.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.in 0
.sp -.5v
.nf
.BX
.in
.sp .5v
.fi
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BM/EM - put colored marker in margin next to block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BM
.if t \{\
.br
.ll -2n
.gcolor red
.di BX
.\}
..
.de EM
.if t \{\
.br
.di
.ll
.gcolor
.nr BH \\n(dn
.ne \\n(BHu
\M[\\$1]\D'P -.75n 0 0 \\n(BHu -(\\n[.i]u - \\n(INu - .75n) 0 0 -\\n(BHu'\M[]
.in 0
.nf
.BX
.in
.fi
.\}
..
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "Name"
abc::messages, abc::errorReturn, abc::consCode, abc::extrSymb, abc::extrSeverity \- error messages and message manipulation functions
.SH "Synopsis"
.fam C
.HP \w'\fBabc::errorReturn\fR\ 'u
\fBabc::errorReturn\fR \fIretArrayName\fR \fIsymbol\fR [\fIpar\fR...]
.fam
.fam C
.HP \w'\fBabc::consCode\fR\ 'u
\fBabc::consCode\fR \fIsymbol\fR [\fIpar\fR...]
.fam
.fam C
.HP \w'\fBabc::extrSymb\fR\ 'u
\fBabc::extrSymb\fR \fIerrorcode\fR
.fam
.fam C
.HP \w'\fBabc::extrSeverity\fR\ 'u
\fBabc::extrSeverity\fR \fIerrorcode\fR
.fam
.SH "DESCRIPTION"
.SS "Symbolic error code structure"
.PP
An
ABCTcl
error code is structured as
\fIsymbol\fR
\fIexplanation\fR\&. The
\fIsymbol\fR
has the form ABC_\fIS\fR_\fIXXX\fR, where
\fIS\fR
is a letter indicating severity, and
\fIXXX\fR
determines the error\&.
\fIexplanation\fR
is a human\-readable text\&.
.SS "Variables"
.PP
\fIabc::messages \fR
.RS 4
An associative array\&. For each error symbol used by
ABCTcl, it contains a human\-readable explanation that can be used by Tcl
\fBformat\fR\&. Set up when the
\FCabctcl\&.tcl\F[]
file is sourced\&.
.RE
.SS "Procedures"
.PP
\fBabc::errorReturn\fR \fIretArrayName\fR \fIsymbol\fR [\fIpar\fR...]
.RS 4
When called from a procedure, it causes that procedure to return with error\&. The Tcl variable
\fI::errorCode\fR
is constructed from the provided
\fIsymbol\fR
and the explanation from
\fIabc::messages\fR, using
\fIpar\fRs when required by the explanation\&. The value is also stored in
\fI\fIretArray\fR\fR\fI(errorCode)\fR\&. Also the value of
\fI::errorInfo\fR
is derived from the constructed error code\&.
.sp
Returns empty string\&. Used internally by all ABCTcl procedures\&.
.RE
.PP
\fBabc::consCode\fR \fIsymbol\fR [\fIpar\fR...]
.RS 4
Returns an error code constructed from the provided
\fIsymbol\fR
and the explanation from
\fIabc::messages\fR, using
\fIpar\fRs when required by the explanation\&. Used internally by
\fBabc::errorReturn\fR\&.
.RE
.PP
\fBabc::extrSymb\fR \fIerrorcode\fR
.RS 4
Returns the error symbol contained in
\fIerrorcode\fR\&.
.RE
.PP
\fBabc::extrSeverity\fR \fIerrorcode\fR
.RS 4
Returns the letter specifying severity from an error code or an error symbol in
\fIerrorcode\fR\&.
.RE
.SH "SYMBOLOIC CODES"
.SS "Notices"
.\" line length increase to cope w/ tbl weirdness
.ll +(\n(LLu * 62u / 100u)
.TS
ll.
\fIError Code\fR	\fIExplanation\fR
T{
ABC_N_EQ_YES
T}	T{
The networks are equivalent\&.
T}
T{
ABC_N_SAT_YES
T}	T{
The formula is satisfiable\&.
T}
T{
ABC_N_EQ_NO
T}	T{
The networks are not equivalent\&.
T}
T{
ABC_N_SAT_NO
T}	T{
The formula is unsatisfiable\&.
T}
T{
ABC_N_EQ_UND
T}	T{
The equivalence of the networks could not be determined\&.
T}
T{
ABC_N_SAT_UND
T}	T{
The satisfiablility of the formula could not be determined\&.
T}
.TE
.\" line length decrease back to previous value
.ll -(\n(LLu * 62u / 100u)
.sp
.SS "File errors"
.\" line length increase to cope w/ tbl weirdness
.ll +(\n(LLu * 62u / 100u)
.TS
ll.
\fIError Code\fR	\fIExplanation\fR
T{
ABC_E_READ
T}	T{
Error reading %s: %s\&.
T}
T{
ABC_E_EXEC
T}	T{
Error executing %s\&.
T}
T{
ABC_E_SUFF
T}	T{
Unknown file suffix %s\&.
T}
T{
ABC_E_OPEN
T}	T{
Error opening file %s\&.
T}
T{
ABC_E_EXF
T}	T{
%s does not exist or is not executable\&.
T}
T{
ABC_E_EXD
T}	T{
%s does not exist or is not a directory\&.
T}
.TE
.\" line length decrease back to previous value
.ll -(\n(LLu * 62u / 100u)
.sp
.SS "ABC errors"
.\" line length increase to cope w/ tbl weirdness
.ll +(\n(LLu * 62u / 100u)
.TS
ll.
\fIError Code\fR	\fIExplanation\fR
T{
ABC_E_PARAMS
T}	T{
Incorrect parameters\&.
T}
T{
ABC_E_CMD
T}	T{
ABC command error: %s\&.
T}
T{
ABC_E_EMPTY
T}	T{
An empty network detected by ABC\&.
T}
T{
ABC_E_PARSE
T}	T{
The output could not be parsed\&.
T}
T{
ABC_E_INCOMP
T}	T{
Compared networks differ in inputs and/or outputs\&.
T}
T{
ABC_E_TOUT
T}	T{
ABC command timeout\&.
T}
T{
ABC_E_EOF
T}	T{
Unexpected end\-of\-file from ABC\&.
T}
T{
ABC_E_BUSY
T}	T{
Another ABC command in progress\&.
T}
.TE
.\" line length decrease back to previous value
.ll -(\n(LLu * 62u / 100u)
.sp
.SH "Author"
.PP
\fBJan CTU in Prague Schmidt\fR <\&jan\&.schmidt@fit\&.cvut\&.cz\&>
.br
CTU in Prague
.RS 4
Wrote manual pages after the original description by Jan Petr, CTU in Prague
.RE
