.\"     Title: abc::print_gates
.\"    Author: Jan CTU in Prague Schmidt <jan.schmidt@fit.cvut.cz>
.\" Generator: DocBook XSL Stylesheets v1.74.0 <http://docbook.sf.net/>
.\"      Date: 12/21/2010
.\"    Manual: Reference Pages
.\"    Source: ABCTcl 0.6
.\"  Language: English
.\"
.TH "ABC::PRINT_GATES" "n" "12/21/2010" "ABCTcl 0.6" "Reference Pages"
.\" -----------------------------------------------------------------
.\" * (re)Define some macros
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" toupper - uppercase a string (locale-aware)
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de toupper
.tr aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ
\\$*
.tr aabbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH-xref - format a cross-reference to an SH section
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de SH-xref
.ie n \{\
.\}
.toupper \\$*
.el \{\
\\$*
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH - level-one heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SH
.\" put an extra blank line of space above the head in non-TTY output
.if t \{\
.sp 1
.\}
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[an-margin]u
.ti 0
.HTML-TAG ".NH \\n[an-level]"
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
\." make the size of the head bigger
.ps +3
.ft B
.ne (2v + 1u)
.ie n \{\
.\" if n (TTY output), use uppercase
.toupper \\$*
.\}
.el \{\
.nr an-break-flag 0
.\" if not n (not TTY), use normal case (not uppercase)
\\$1
.in \\n[an-margin]u
.ti 0
.\" if not n (not TTY), put a border/line under subheading
.sp -.6
\l'\n(.lu'
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SS - level-two heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SS
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[IN]u
.ti \\n[SN]u
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
.ps \\n[PS-SS]u
\." make the size of the head bigger
.ps +2
.ft B
.ne (2v + 1u)
.if \\n[.$] \&\\$*
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BB/BE - put background/screen (filled box) around block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BB
.if t \{\
.sp -.5
.br
.in +2n
.ll -2n
.gcolor red
.di BX
.\}
..
.de EB
.if t \{\
.if "\\$2"adjust-for-leading-newline" \{\
.sp -1
.\}
.br
.di
.in
.ll
.gcolor
.nr BW \\n(.lu-\\n(.i
.nr BH \\n(dn+.5v
.ne \\n(BHu+.5v
.ie "\\$2"adjust-for-leading-newline" \{\
\M[\\$1]\h'1n'\v'+.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.el \{\
\M[\\$1]\h'1n'\v'-.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.in 0
.sp -.5v
.nf
.BX
.in
.sp .5v
.fi
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BM/EM - put colored marker in margin next to block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BM
.if t \{\
.br
.ll -2n
.gcolor red
.di BX
.\}
..
.de EM
.if t \{\
.br
.di
.ll
.gcolor
.nr BH \\n(dn
.ne \\n(BHu
\M[\\$1]\D'P -.75n 0 0 \\n(BHu -(\\n[.i]u - \\n(INu - .75n) 0 0 -\\n(BHu'\M[]
.in 0
.nf
.BX
.in
.fi
.\}
..
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "Name"
abc::print_gates \- report staistics of gate types
.SH "Synopsis"
.fam C
.HP \w'\fBabc::print_gates\fR\ 'u
\fBabc::print_gates\fR [\fIresult\fR] [\fIparameters\fR] [\fItimeout\fR]
.fam
.SH "DESCRIPTION"
.PP
Sends the command
\fBprint_gates \fR\fB\fIparameters\fR\fR
to
ABC
and waits for a prompt\&. Parses the output and converts values reported by
ABC
to items in the
\fIresult\fR
array\&.
.SH "ARGUMENTS"
.PP
array \fIresult \fR(out)
.RS 4
Optional argument\&. If omitted, no information is returned\&. The following items are present:
.PP
string \fIerrorCode\fR (out)
.RS 4
Error code\&. See
\c
.SH-xref "RETURN CODES\c"
\&
below\&. Also put to the
\fIerrorCode\fR
global variable\&.
.RE
.PP
string \fIrawOutput\fR (out)
.RS 4
The unprocessed output of
ABC, including the final prompt\&.
.RE
.PP
int \fIpromptNumber \fR(out)
.RS 4
The number included in the final prompt\&. The
ABC
prompt has the "abc123> " form\&. The number indicates successive version of the network stored in
ABC\&.
.RE
.PP
int \fIcmdTime \fR(out)
.RS 4
Time in milliseconds elapsed by the command\&.
.RE
.PP
int \fIconst\fR, float \fIconst_percent \fR(out)
.RS 4
Number and percentage of constant generators (logical 0, 1)\&.
.RE
.PP
int \fIbuffer\fR, float \fIbuffer_percent \fR(out)
.RS 4
Number and percentage of buffers\&.
.RE
.PP
int \fIinverter\fR, float \fIinverter_percent \fR(out)
.RS 4
Number and percentage of inverters\&.
.RE
.PP
int \fIand\fR, float \fIand_percent \fR(out)
.RS 4
Number and percentage of AND gates, including gates derived from AND by inversion of inputs, e\&.g\&. NOR\&.
.RE
.PP
int \fIor\fR, float \fIor_percent \fR(out)
.RS 4
Number and percentage of OR gates, including gates derived from OR by inversion of inputs, e\&.g\&. NAND\&.
.RE
.PP
int \fIother\fR, float \fIother_percent \fR(out)
.RS 4
Number and percentage of other gates, i\&. e\&. XOR and XNOR\&.
.RE
.PP
int \fItotal\fR, float \fItotal_percent \fR(out)
.RS 4
Number and percentage of all gates\&. The percentage is always 100%\&.
.RE
.RE
.PP
string \fIparameters \fR(in)
.RS 4
Optional argument\&. Parameters for the
ABC
\fBprint_gates\fR
command\&. Defaults to an empty string\&.
.RE
.PP
int \fItimeout \fR(in)
.RS 4
Optional argument\&. If given, sets the timeout of Expect for this command\&. Othervise, the value of the
\fItimeout\fR
global variable applies\&.
.RE
.SH "RETURN CODES"
.PP
The procedure returns an empty string\&. See
\fBabctcl\fR(n),
\fBabc::messages\fR(n)
for error reporting and error symbols\&. The following error symbols can occur:
.\" line length increase to cope w/ tbl weirdness
.ll +(\n(LLu * 62u / 100u)
.TS
ll.
\fIError Code\fR	\fIDiagnostic\fR
T{
ABC_E_BUSY
T}	T{
Prompt from the previous command has not been detected yet\&.
T}
T{
ABC_E_EOF
T}	T{
A premature end\-of\-file detected\&. Perhaps the ABC process crashed\&.
T}
T{
ABC_E_TOUT
T}	T{
Timeout expired before the prompt was detected\&.
T}
T{
ABC_E_PARAMS
T}	T{
ABC could not interpret \fIparameters\fR\&.
T}
T{
ABC_E_PARSE
T}	T{
\fBabc::print_gates\fR could not parse the output of ABC\&. A new version with different labels might be in use\&.
T}
T{
ABC_E_EMPTY
T}	T{
The current circuit description in ABC is empty\&. Use \fBabc::read\fR\&.
T}
.TE
.\" line length decrease back to previous value
.ll -(\n(LLu * 62u / 100u)
.sp
.SH "SEE ALSO"
.PP

\fBabctcl\fR(n),
\fBabc::messages\fR(n)
.SH "Author"
.PP
\fBJan CTU in Prague Schmidt\fR <\&jan\&.schmidt@fit\&.cvut\&.cz\&>
.br
CTU in Prague
.RS 4
Wrote manual pages after the original description by Jan Petr, CTU in Prague
.RE
