.\"     Title: abctcl
.\"    Author: Jan CTU in Prague Schmidt <jan.schmidt@fit.cvut.cz>
.\" Generator: DocBook XSL Stylesheets v1.74.0 <http://docbook.sf.net/>
.\"      Date: 12/21/2010
.\"    Manual: Reference Pages
.\"    Source: ABCTcl 0.6
.\"  Language: English
.\"
.TH "ABCTCL" "n" "12/21/2010" "ABCTcl 0.6" "Reference Pages"
.\" -----------------------------------------------------------------
.\" * (re)Define some macros
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" toupper - uppercase a string (locale-aware)
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de toupper
.tr aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ
\\$*
.tr aabbccddeeffgghhiijjkkllmmnnooppqqrrssttuuvvwwxxyyzz
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH-xref - format a cross-reference to an SH section
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de SH-xref
.ie n \{\
.\}
.toupper \\$*
.el \{\
\\$*
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SH - level-one heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SH
.\" put an extra blank line of space above the head in non-TTY output
.if t \{\
.sp 1
.\}
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[an-margin]u
.ti 0
.HTML-TAG ".NH \\n[an-level]"
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
\." make the size of the head bigger
.ps +3
.ft B
.ne (2v + 1u)
.ie n \{\
.\" if n (TTY output), use uppercase
.toupper \\$*
.\}
.el \{\
.nr an-break-flag 0
.\" if not n (not TTY), use normal case (not uppercase)
\\$1
.in \\n[an-margin]u
.ti 0
.\" if not n (not TTY), put a border/line under subheading
.sp -.6
\l'\n(.lu'
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" SS - level-two heading that works better for non-TTY output
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de1 SS
.sp \\n[PD]u
.nr an-level 1
.set-an-margin
.nr an-prevailing-indent \\n[IN]
.fi
.in \\n[IN]u
.ti \\n[SN]u
.it 1 an-trap
.nr an-no-space-flag 1
.nr an-break-flag 1
.ps \\n[PS-SS]u
\." make the size of the head bigger
.ps +2
.ft B
.ne (2v + 1u)
.if \\n[.$] \&\\$*
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BB/BE - put background/screen (filled box) around block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BB
.if t \{\
.sp -.5
.br
.in +2n
.ll -2n
.gcolor red
.di BX
.\}
..
.de EB
.if t \{\
.if "\\$2"adjust-for-leading-newline" \{\
.sp -1
.\}
.br
.di
.in
.ll
.gcolor
.nr BW \\n(.lu-\\n(.i
.nr BH \\n(dn+.5v
.ne \\n(BHu+.5v
.ie "\\$2"adjust-for-leading-newline" \{\
\M[\\$1]\h'1n'\v'+.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.el \{\
\M[\\$1]\h'1n'\v'-.5v'\D'P \\n(BWu 0 0 \\n(BHu -\\n(BWu 0 0 -\\n(BHu'\M[]
.\}
.in 0
.sp -.5v
.nf
.BX
.in
.sp .5v
.fi
.\}
..
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" BM/EM - put colored marker in margin next to block of text
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.de BM
.if t \{\
.br
.ll -2n
.gcolor red
.di BX
.\}
..
.de EM
.if t \{\
.br
.di
.ll
.gcolor
.nr BH \\n(dn
.ne \\n(BHu
\M[\\$1]\D'P -.75n 0 0 \\n(BHu -(\\n[.i]u - \\n(INu - .75n) 0 0 -\\n(BHu'\M[]
.in 0
.nf
.BX
.in
.fi
.\}
..
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "Name"
abctcl \- control the ABC synthesis system
.SH "DESCRIPTION"
.PP
ABCTcl
is a collection of procedures that control the
ABC
synthesis system using
Expect\&. A typical procedure of the collection performs a single
ABC
command, then parses its output and provide it in an array\&.
.PP
The following procedures are defined\&. For detailed description, see their respective manual pages\&.
.PP
\fBabc::init\fR [\fIresult\fR] [\fItimeout\fR]
.RS 4
Starts ABC, commands it to source configured initialization files\&.
.RE
.PP
\fBabc::done\fR
.RS 4
Commands ABC to stop and closes the communication\&.
.RE
.PP
\fBabc::command\fR \fIcommand\fR [\fIresult\fR] [\fItimeout\fR]
.RS 4
Sends
\fIcommand\fR
to
ABC\&. No parsing is done on its output\&.
.RE
.PP
\fBabc::source\fR \fIfile\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR]
.RS 4
Commands ABC to source an ABC script\&.
.RE
.PP
\fBabc::read\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR]
.RS 4
Commands ABC to read a circuit description\&. The type of the input is determined by the suffix of the file\&.
.RE
.PP
\fBabc::print_stats\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::print_latch\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::print_auto\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::print_fanio\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::print_gates\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::print_symm\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::print_unate\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR]
.RS 4
Invoke respective ABC commands\&. Parse the output so that the reported data can be used for evaluation and control\&.
.RE
.PP
\fBabc::sec\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::cec\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::dsec\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::dprove\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR]
.RS 4
Check circuit equivalence using respective ABC commands\&.
.RE
.PP
\fBabc::iprove\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::prove\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR], \fBabc::sat\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR]
.RS 4
Solve an instance of the boolean satisfiability problem using respective ABC commands\&.
.RE
.PP
\fBabc::time\fR [\fIresult\fR] [\fIparams\fR] [\fItimeout\fR]
.RS 4
Obtain and parse ABC time report\&.
.RE
.SH "RETURN CODES"
.PP
The equivalence checking procedures and satisfiability procedures return a structured string (see
\fBabc::messages\fR(n)) indicating their results\&. Other procedures return empty strings\&. All procedures use
.PP
\fBreturn\fR
\-code ok
.PP
if no error occurs,
.PP
\fBreturn\fR
\-code error \-errorcode
\fIcode\fR
\-errorinfo
\fIinfo\fR
.PP
otherwise\&.
\fIcode\fR
defaults to
\fBNONE\fR
if no error occured\&. See
\fBabc::messages\fR(n)
for the structure of
\fIcode\fR
and
\fIinfo\fR
for possible values and their semantics\&.
.SH "CONFIGURATION"
.PP
ABCTcl
uses the file
\FCabctcl\&.conf\&.tcl\F[]
for configuration\&. It searches for that file in the same directory where
\FCabctcl\&.tcl\F[]
is located\&. The file itself is Tcl code\&. For variables that can be configured there, see
\fBabctcl.conf.tcl\fR(5)\&.
.SH "EXAMPLE"
.PP
The program below is a tiny but complete example\&. It reads a circuit from a file specified on the command line and decides whether it is sequential or combinatorial\&. The locations of
\fBtclsh\fR
and
\FCabctcl\&.tcl\F[]
may, of course, vary\&.
.sp
.if n \{\
.RS 4
.\}
.fam C
.ps -1
.nf
.if t \{\
.sp -1
.\}
.BB lightgray adjust-for-leading-newline
.sp -1

#!/usr/bin/tclsh
source /usr/local/libexec/abctcl\&.tcl

abc::init
abc::read {} [lindex $argv 0]
abc::print_latch result
if {$result(total_latches) == 0} {
   puts "combinational"
} else {
   puts "sequential"
}
abc::done
.EB lightgray adjust-for-leading-newline
.if t \{\
.sp 1
.\}
.fi
.fam
.ps +1
.if n \{\
.RE
.\}
.SH "BUGS"
.PP
The collection should be installed as a Tcl package\&.
.SH "SEE ALSO"
.PP

\fBabctcl.conf.tcl\fR(5),
\fBabc::messages\fR(n),
\fBabc::init\fR(n),
\fBabc::done\fR(n),
\fBabc::command\fR(n),
\fBabc::source\fR(n),
\fBabc::read\fR(n),
\fBabc::print_stats\fR(n),
\fBabc::print_latch\fR(n),
\fBabc::print_auto\fR(n),
\fBabc::print_fanio\fR(n),
\fBabc::print_gates\fR(n),
\fBabc::print_symm\fR(n),
\fBabc::print_unate\fR(n),
\fBabc::sec\fR(n),

\fBabc::sat\fR(n),
\fBabc::time\fR(n)
.SH "Author"
.PP
\fBJan CTU in Prague Schmidt\fR <\&jan\&.schmidt@fit\&.cvut\&.cz\&>
.br
CTU in Prague
.RS 4
Wrote manual pages after the original description by Jan Petr, CTU in Prague
.RE
